#include "nevo.h"
#include <values.h>
#include <memory.h>

extern char comp_player;
extern int stopnow;
extern int stoptime;
extern play_board arrboard[10];
extern int Wcount[10];
extern int Bcount[10];
extern int Wdist[10];
extern int Bdist[10];

int gLook;

/************************************************************/
/*  Chooses one of the moves based on the heuristic as well */
/*  as the search (eventually).                             */
/************************************************************/
get_comp_move(m,player,look)
Mptr m;
char player;
int look;
{
   int tmp_hval;
   int pass,use;
   char opponent;
   movelist ml;
   int i=0;
   int do_copy;
   int max= -1;

   gLook=look;
   pass = -1*MAXINT;
   use = MAXINT;
   opponent = (player=='B')?'W':'B';
   stopnow=0;
   alarm(stoptime-1);
   MoveGen(player,&ml,0);
   do_copy=1;
   while ((i<ml.nummoves)&&(!stopnow))
     {
      if(do_copy)
        {
         memcpy(arrboard[1],arrboard[0],sizeof(play_board));
	 Wcount[1]=Wcount[0];
	 Bcount[1]=Bcount[0];
	 Wdist[1]=Wdist[0];
	 Bdist[1]=Bdist[0];
        }
      do_copy=ApplyMove(&ml.mval[i],1);
      
      tmp_hval = -minimax(1,opponent,look-1,-pass,-use);
      if(do_copy==0) UnApplyMove(&ml.mval[i],1);
/* possible undo move */
      printw(" %d ",tmp_hval);refresh(); 
      if (tmp_hval>pass)
        {
	 pass = tmp_hval;
	 max = i;
        } 
      i++;
     }       
   if(stopnow) 
      printw("Stopped early, returning best so far.\n");
   refresh();
   m->oldx=ml.mval[max].oldx;
   m->oldy=ml.mval[max].oldy;
   m->newx=ml.mval[max].newx;
   m->newy=ml.mval[max].newy;
   alarm(0);
   return max;
}

/************************************************************/
/* minimax finds the best move by searching ahead           */
/************************************************************/
int minimax(board,team,lev,use,pass)
int board;
char team;
int lev;
int use,pass;
{
   int tmp_hval;
   char opponent;
   int i;
   int max;
   int do_copy;
   movelist ml;

   if(lev==0)
     {
      if ((gLook % 2)==0) {
      	return ((comp_player=='W')?1:-1)*heuristic(board);
      }
      else {
      	return ((comp_player=='W')?-1:1)*heuristic(board);
      }
     }
    else
     {
      opponent=(team=='B')?'W':'B';
      MoveGen(team,&ml,board);
      i=0;
      do_copy=1;
      while ((i<(ml.nummoves))&&(!stopnow))
        {
         if(do_copy)
          {
	   memcpy(arrboard[board+1],arrboard[board],sizeof(play_board));
	   Wcount[board+1]=Wcount[board];
	   Bcount[board+1]=Bcount[board];
	   Wdist[board+1]=Wdist[board];
	   Bdist[board+1]=Bdist[board];
          }
         do_copy=ApplyMove(&ml.mval[i],board+1);
      
         tmp_hval = -minimax(board+1,opponent,lev-1,-pass,-use);
         if(do_copy==0) UnApplyMove(&ml.mval[i],board+1);
         if (tmp_hval>pass)
           {
	    pass = tmp_hval;
	    max = i;
           } 
      	 if(pass>use)
           return pass;
         i++;
        }       
      return pass;
     }
}
