/* Main loop */

#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include "nevo.h"

/****************/
play_board arrboard[10];
int Wcount[10];
int Bcount[10];
int Wdist[10];
int Bdist[10];

char comp_player;
int stopnow;
int stoptime;
int regular=0;
/****************/

void new_init()
 {
  FILE *fp;
  int i,j;
 
  fp=fopen("start.game","r");
  for(i=0;i<7;i++)
   {
    for(j=0;j<12;j++)
      if((arrboard[0][j][i]=fgetc(fp))=='-') arrboard[0][j][i]=' ';
    fgetc(fp);
   }
  close(fp);
  Wcount[0] = Bcount[0] = 12;
  Wdist[0] = Bdist[0] = 12;
 }

/******************************************************************/
/*                Procedures to print the board                   */
/******************************************************************/
void display_board(int b)
 {
  int i,j;
 
  clear();
  move(0,1);
  printw("     *   *     *   * 1 1"); 
  move(1,1);
  printw(" 0 1 2 3 4 5 6 7 8 9 0 1");
  move(0,40); printw("White: %d",ScoreBoard('W',b));
  move(1,40); printw("Black: %d",ScoreBoard('B',b));
  move(2,1);
  printw("-------------------------\n");
  for(i=0;i<7;i++)
   {
    printw("%d|",i);
    for(j=0;j<12;j++)
      printw("%c|",arrboard[b][j][i]);
    printw("\n -------------------------\n");
   }
  refresh();
 }

/******************************************************************/
/* get look determines the look ahead level                       */
/******************************************************************/
int getlook()
 {
  int retval;
 
  printw("Please enter the look ahead value>");
  refresh();
  scanw("%d",&retval);
  while((retval<1)||(retval>10))
   {
    printw("Must be from 1 to 10.\n"); 
    printw("Please enter the look ahead value>");
    refresh();
    scanw("%d",&retval);
   }
  if(regular)
  {
  printw("Please enter who the computer player will be>");
  refresh();
  scanw("%c",&comp_player);
  comp_player=toupper(comp_player);
  while((comp_player!='B')&&(comp_player!='W')&&(comp_player!='N'))
   {
    printw("Must be from B or W.\n"); 
    printw("Please enter who the computer player will be>");
    refresh();
    scanw("%c",&comp_player);
    comp_player=toupper(comp_player);
   }
  }
  printw("Please enter the maximum time allowed for the computer>");
  refresh();
  scanw("%d",&stoptime);
  while((stoptime<10)||(stoptime>3000))
   {
    printw("Must be from 10 to 3000.\n"); 
    printw("Please enter the maximum time allowed for the computer>");
    refresh();
    scanw("%d",&stoptime);
   }
  return retval; 
 }

/******************************************************************/
/*  Signal handler for the recursive stop                         */
/******************************************************************/
void setstop()
 {
  stopnow=1;
 }

hit_key()
 {
printw("\nHit enter to continue.\n");
refresh();
getchar();
refresh();
 }

/******************************************************************/
/*                           MAIN                                 */
/******************************************************************/
main(int argc,char *argv[])
 {
  char whose_turn='W';
  struct move_piece mov;
  int look;
  char move[4];

  if(argc<2)
    regular=1;
  if(!regular)
    switch (make_connection(argv[1])) {
      case 1: comp_player='W';
	      break;
      case 0: comp_player='B';
	      break;
      default: fprintf(stderr,"Error in connect\n");
		exit(1);
    }
  srand(getpid());
  signal(SIGALRM,setstop);
  new_init();
  initscr();
  if(regular) {
    scrollok(stdscr,TRUE);
    display_board(0);
   }
  look=getlook();
  while(1)
   {
    if(whose_turn==comp_player)
      {
       get_comp_move(&mov,whose_turn,look);
       ApplyMove(&mov,0);
       if(!regular)
	{
	 move[0]=(comp_player=='W')?6-mov.oldy:mov.oldy;
	 move[1]=mov.oldx;
	 move[2]=(comp_player=='W')?6-mov.newy:mov.newy;
	 move[3]=mov.newx;
         send_move(move);
	}
      }
     else
      {
       if(!regular)
         {
          while(recv_move(move)==-1)
	   sleep(1);
	  if(move[0] == -1) exit(1);
	  mov.oldy=(comp_player=='W')?6-move[0]:move[0];
	  mov.oldx=move[1];
	  mov.newy=(comp_player=='W')?6-move[2]:move[2];
	  mov.newx=move[3];
         }
        else
        {
	/*
	 comp_player = (comp_player=='W')?'B':'W';
         get_comp_move(&mov,whose_turn,look-1);
	 comp_player = (comp_player=='W')?'B':'W';
	*/
         get_move_key(whose_turn,&mov); 
        }
       ApplyMove(&mov,0);
      }
    display_board(0);
    if(WinGame(whose_turn,0))
     {
      printw("%s has Won!!!!!!!\n",(whose_turn=='W')?"WHITE":"BLACK");
      hit_key();
      if(!regular) disconnect();
      exit(0);
     }
    whose_turn=(whose_turn=='W')?'B':'W';
   }
 }

int make_connection(char *s)
{
 return 0; 
}

int send_move(int move[])
{
}

int recv_move(int move[])
{
 printf("Enter move: oldy oldx newy newx\n");
 scanf("%d %d %d %d",&move[0],&move[1],&move[2],&move[3]);
 return 1;
}

int disconnect()
{
}

